#!/bin/perl
#############################################################
# WebSphere Usage Statistics
# =========================
# Copyright (C) 2013
# =========================
# Description: 
# The program gathers usage statistics from WebSphere
# and places them under node "JVM Stats"
# =========================
# Usage: perl <epa_home>/epaplugins/rhel/psWASforLinux.pl
#############################################################
use FindBin;
use lib ("$FindBin::Bin", "$FindBin::Bin/lib/perl", "$FindBin::Bin/../lib/perl");
use Wily::PrintMetric;

use strict;

my $psCommand='ps -eaf|awk \'/(WebSphere\/.*\/java)/&&!/grep/{print $2}\'|xargs -n1 ps vww|awk \'NF>5&&!/PID/{printf "%s\t%s\t%s\n",$8,$9,$NF;t+=$7;c+=$11}\'';
my @psResults=`$psCommand`;

# output results
#RSS	 CPU	 AppServer	# HEADER IS NOT DISPLAYED	
#29272   0.4     app1
#94428   0.4     app2
#45820   0.5     nodeagent
#48476   0.3     app3
#62148   0.6     app4
#55352   0.3     app5

# initialize counter for total resident memory
my $total=0;

# parse results
foreach my $line (@psResults){
	chomp $line;
	# split the row
	my @jvmStats=split /\t/, $line;
    if ($jvmStats[2] =~ /^-[DX].*$/o) { next; }
	($total+=$_) for $jvmStats[0];
	# print metrics
	Wily::PrintMetric::printMetric(	type		=> 'StringEvent',
									resource	=> 'JVM Stats',
									subresource	=> $jvmStats[2],
									name		=> 'CPU (%)',
									value		=> $jvmStats[1],
								  );
	Wily::PrintMetric::printMetric(	type		=> 'IntCounter',
									resource	=> 'JVM Stats',
									subresource	=> $jvmStats[2],
									name		=> 'RSS',
									value		=> int($jvmStats[0]),
								  );
}
# print the total resident memory usage
Wily::PrintMetric::printMetric(	type		=> 'LongCounter',
								resource	=> 'JVM Stats',
								name		=> 'Total Resident Memory (KB)',
								value		=> $total,
							  );
